/*
 * This is a sample solution file which will earn an F.
 */

#include <limits.h>
#include <assert.h>
#include "assn3.h"

int	current_problem;

int	client_op(unsigned short	*buflenp,
		  char			**bufpp)
{
	static char	buffer[USHRT_MAX];
	static char	md5_preimage[100] = {
		0x01, 0x02, 0x03, 0x04,
		0x01, 0x02, 0x03, 0x04,
	};
	static int	state = 0;
	unsigned long	ul;
	unsigned short	us;

	switch (state++) {
	case 0:
		strcpy(buffer,"Joe Six-pack");
		*bufpp = buffer;
		*buflenp = strlen(buffer) + 1;	/* incl null */
		return OP_STUDENT_ID;
	case 1:
		current_problem = 1;
		us = htons(current_problem);
		memcpy(buffer,&us,sizeof us);
		*bufpp = buffer;
		*buflenp = sizeof us;
		return OP_SET_PROBLEM_NUM;
	case 2:
		ul = htonl(362880);
		memcpy(buffer,&ul,sizeof ul);
		*bufpp = buffer;
		*buflenp = sizeof ul;
		return OP_MORE_DATA;
	case 3:
		return OP_EVALUATE;
	case 4:
		current_problem = 2;
		us = htons(current_problem);
		memcpy(buffer,&us,sizeof us);
		*bufpp = buffer;
		*buflenp = sizeof us;
		return OP_SET_PROBLEM_NUM;
	case 5:
		*bufpp = md5_preimage;
		*buflenp = sizeof md5_preimage;
		return OP_MORE_DATA;
	case 6:
		*bufpp = md5_preimage;
		*buflenp = sizeof md5_preimage;
		return OP_MORE_DATA;
	case 7:
		return OP_EVALUATE;
	case 8:
		return OP_DONE;
	}
}

void	client_answer(int		op,
		      unsigned short	buflen,
		      const char	*buffer)
{
	unsigned long	score;

	switch (op) {
	case RESP_SCORE:
		assert(buflen == sizeof score);
		memcpy(&score,buffer,sizeof score);
		score = ntohl(score);
		printf("CLIENT_OUTPUT: Score for problem %d is %d\n",current_problem,score);
		break;
	case RESP_FINAL_SCORE:
		memcpy(&score,buffer,sizeof score);
		score = ntohl(score);
		printf("CLIENT_OUTPUT: Total score is %d, grade %s\n",score,buffer + sizeof score);
		break;
	}
}
